********************************************************************
* lwasm -r -o/tmp/date.bin date.asm -b -l > /tmp/date.lst
*
* 2014 Tormod Volden
*
* DriveWire time display dweeb for dwload
* Usage example: DLOAD"DATE"

OUTNUM   equ   $957A            print number in D to DEVNUM
OUTCHR   equ   $B54A            print char A to DEVNUM
OUTSTR   equ   $90E5            print string at X+1 to DEVNUM
IOERROR  equ   $B84B		IO_error
IntMasks equ   $50

Start    equ   $7D00
 
         org   Start

Entry

* Get DW routine addresses from calling DWLOAD

	 ldu   ,s		get stacked PC
         ldx   1,u
         stx   DWReadv
         ldx   3,u
         stx   DWWritev

	 orcc  #IntMasks

* DriveWire time request

         ldx   #timeop
         ldy   #1
         jsr   [DWWritev]

         ldx   #timerep
         ldy   #6
	 clra  * for BECKER carry clear
         jsr   [DWReadv]
         bcs   Failed
         bne   Failed

         clra
         ldb   timerep
         addd  #1900
         jsr   OUTNUM
         lda   #'-
         jsr   OUTCHR
         ldb   timerep+1
         bsr   print2d
         lda   #'-
         jsr   OUTCHR
         ldb   timerep+2
         bsr   print2d
         lda   #' '
         jsr   OUTCHR
         ldb   timerep+3
         bsr   print2d
         lda   #':
         jsr   OUTCHR
         ldb   timerep+4
         bsr   print2d
         lda   #':
         jsr   OUTCHR
         ldb   timerep+5
         bsr   print2d
	 andcc  #~IntMasks
         rts

print2d  cmpb  #9
         bhi   twod
         lda   #'0'
         jsr   OUTCHR
twod     clra
         jmp   OUTNUM

Failed
         jmp   IOERROR

DWReadv  fdb   0
DWWritev fdb   0
timeop   fcb   $23
timerep  rmb   6
         end   Entry
