********************************************************************
* lwasm -r --pragma=condundefzero -o/tmp/dosn.bin dosn.asm -b -l > /tmp/dosn.lst
*
* 2014 Tormod Volden
*
* dwdos/DOS app for dwload
* Usage example: DLOAD"DOS"3 (to boot from drive 3)

Start    equ   $7D00

bootflag equ   $11
dnum     equ   $12

IntMasks equ   $50
 
* Entry point
         org   Start

ldtext   fcn   /LOADING BOOT TRACK/
DoReadv  fdb   0

Entry
         clrb			default drive 0
         lda   <bootflag	command line or autoboot
         bne   defaultn		autoboot = $55
         jsr   <$a5             peek at next char
         beq   defaultn
         jsr   $8E51            Get8Bit
defaultn 
	 stb   <dnum

	 ldx   #ldtext-1
         jsr   $90E5

* Get DoRead routine address from calling DWLOAD

	 ldx   ,s		get stacked PC
	 ldx   5,x		DoRead vector (after RTS, DWRead and DWWrite)
	 stx   DoReadv		store copy

	 orcc  #IntMasks

* DriveWire bootstrap code
* Get sectors 612-629 to $2600

dos      ldx   #612		starting sector number
         ldy   #$2600

DOSLoop  jsr   [DoReadv]	read sector (into Y)
         bcs   Failed		start all over
         bne   Failed
         cmpx  #612		our first sector?
         bne   not1st		branch if not
         ldd   ,y		else get two bytes at $2600
         cmpd  #$4F53		OS?
         bne   noos
not1st
         lda   #'*+$40		print star
         leay  256,y
sect2    leax  1,x		else increment X
         sta   1024+32*5-612-1,x	print progress
         cmpx  #630		are we at last sector?
         blt   DOSLoop		branch if not
         
         lda   #'!+$40		print bang
         sta   636-1,x
         jmp   $2602

noostxt  fcb   $0D
         fcn   /NOT AN OS BOOT TRACK/
noos     ldx   #noostxt-1
         jsr   $90E5		print string at x+1
Failed   jmp   $B84B		IO_error equ $B84B

         end   Entry

